<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<!--
*  Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
*  Use is subject to license terms.
-->
<html>

<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">

<title>Creating a Three-Tier Mobile Web Services Client </title>

<link rel="StyleSheet" href="nbdocs:/org/netbeans/modules/usersguide/ide.css" type="text/css">
</head>

<body>

<h2>Creating a Three-Tier Mobile Web Services Client </h2>

<p><small><a href="#seealso">See Also</a></small>


<p>With the Mobile Client to Web Application Generator, you create a MIDP client, 
  a servlet and supporting files to enable a MIDlet to communicate with a Web 
  service. This type of connection utilizes three &quot;tiers&quot;: client, web 
  application containing servlet, and server. The client communicates with the generated 
  middleware servlet using a proprietary communication protocol. The servlet and 
  server communicate using standard Simple Object Access Protocol (SOAP) messages. 
</p>
<ul>
  <p>The code generated by the Mobile Client to Web Application Generator has 
    a footprint that can be as small as 3 kilobytes, so it can be deployed on 
    low-end Java ME MIDP devices. The network bandwidth used in calls from the 
    client to the server is also efficient, typically using only slightly more 
    than the minimum needed to transfer the raw data. </p>
  <p>The Mobile Client to Web Application Generator creates: </p>
  <ul>
    <li>A Java ME client class</li>
    <li>A servlet and supporting classes</li>
    <li>A mapping file in xml format that can be used to regenerate the server 
      and Java ME client classes.</li>
    <li>Optionally, a MIDlet you can examine and modify. </li>
  </ul>
</ul>
<p><strong>To create a mobile client to Web service application:</strong> </p>
<ol>
  <li>Right-click on a project node (or create a new<a href="../projects/proj_creating.html"> 
    Mobile application project</a> that is not a Hello MIDlet application) and 
    choose New File/Folder.</li>
  <li>In the New File wizard, choose MIDP under Categories. Under File Types, 
    choose Mobile Client to Web Application. </li>
  <li>In the Servlet and Client Type Selection page, select the desired Web application 
    (if more than one is available) . <br>
    The drop-down menu lists all open Web Applications. If you do not see the 
    Web Application you want, choose Open Web Application and navigate to the 
    project folder you want to open. </li>
  <li>Enter a name for the generated servlet, then choose a location and package 
    for the servlet from the drop-down menus. </li>
  <li>Specify whether the mobile client will connect through methods in the Web 
    application or a Web service client in the Web application. Click Next to 
    continue. </li>
  <li>If you choose Methods in Web Application, the next page is the Methods in 
    Web Project page. <br>
    If you choose Web Service Client in Web Application, the next page is the 
    Web Service Operations page. </li>
   
  <ul>
    <li>The Methods in Web Projects page shows the available methods within the 
      selected Web project. Check the methods you want the client to use.</li>
    <li>The Web Service Operations page shows the available services within the 
      selected Web project. <br>
      Check the methods you want the client to use.</li>
  </ul>
  <p>Click Next.</p>
  <li>Then select from the following generation options: 
    <ul>
      <li><strong>Generate stubs. </strong>Generates stub (client-side proxy) 
        methods on the client for each exported service. Method names are incorporated 
        in the class name. Using<tt> HelloService</tt> for example, the <tt>sayHello()</tt> 
        method is exported. The generated stub method creates a method on the 
        client called <tt>example_HelloService_sayHello().</tt> If this option 
        is not selected, only one method is generated on the client.</li>
      <li><strong>Allow floating point.</strong> Activates support for float and 
        double data types.</li>
    </ul>
  <li>Click the Finish button.<br>
    The settings file is opened in the Editor. Client stubs are generated in the 
    background.</li>
  <li>Build and deploy the server application. Note that new files were created 
    in the Web project.</li>
  <li>After the server application is deployed, you can run your Mobile project 
    and test the generated client.</li>
</ol>
    
<ul class="note">
  <li>Only one client per one WSDL file is supported. You can create more clients 
    or create a composite service and access through the Mobile Client to Web 
    Application Generator via a generic service mode.</li>
  <li>The same applies for special data types like enumerations and other non 
    WS-I compliant data types. A wrapper class can be created and accessed via 
    the Mobile Client to Web Application Generator as well.</li>
  <li>Secure URLs are not currently supported by the Mobile Client to Web Application 
    Generator if they are behind a firewall and require proxy settings. In that 
    case, you must download the WSDL file using your web browser.</li>
  <li>JDK 1.5 is required for creating Web services. If you do not have JDK 1.5 
    or you are limited to JDK 1.4 , you can download extra modules from the Auto 
    Update center (Tools&gt;Update Center).</li>
  <li>The generated files should not be edited. Any changes made to the files 
    (except the sample MIDlet) are lost when you <a href="wcw_updatingjsr172.html">regenerate</a> 
    them.</li>
</ul>
    <dl>
  <dt><a name="seealso">See Also</a></dt>
  <dd>
  </dd>
    <dt><a href="wcw_creating.html">Creating a MIDP Client/Server Application</a></dt>
    
  <dd><a href="wcw_updatingjsr172.html">Updating Java ME Web Services Client Files</a></dd>
    <dt>&nbsp;</dt>
</dl>
<hr>
<small><a href="../getstarted/credits.html">Legal Notices</a></small> 
<table border="0" cellpadding="20">

  <tr>

    <td>&nbsp;</td>

  </tr>

  <tr>

    <td>&nbsp;</td>

  </tr>

  <tr>

    <td>&nbsp;</td>

  </tr>

</table>

</body>

</html>

